/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 12, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corefoundation.CFTimeZone;

import dstep.corefoundation.CFArray;
import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFData;
import dstep.corefoundation.CFDate;
import dstep.corefoundation.CFDictionary;
import dstep.corefoundation.CFLocale;
import dstep.corefoundation.CFString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

alias int CFTimeZoneNameStyle;

extern (C)
{
	extern
	{
		const CFStringRef kCFTimeZoneSystemTimeZoneDidChangeNotification;
	}
}

enum
{
	kCFTimeZoneNameStyleStandard,
	kCFTimeZoneNameStyleShortStandard,
	kCFTimeZoneNameStyleDaylightSaving,
	kCFTimeZoneNameStyleShortDaylightSaving
}

extern (C)
{
	uint CFTimeZoneGetTypeID ();
	CFTimeZoneRef CFTimeZoneCopySystem ();
	void CFTimeZoneResetSystem ();
	CFTimeZoneRef CFTimeZoneCopyDefault ();
	void CFTimeZoneSetDefault (CFTimeZoneRef tz);
	CFArrayRef CFTimeZoneCopyKnownNames ();
	CFDictionaryRef CFTimeZoneCopyAbbreviationDictionary ();
	void CFTimeZoneSetAbbreviationDictionary (CFDictionaryRef dict);
	CFTimeZoneRef CFTimeZoneCreate (CFAllocatorRef allocator, CFStringRef name, CFDataRef data);
	CFTimeZoneRef CFTimeZoneCreateWithTimeIntervalFromGMT (CFAllocatorRef allocator, double ti);
	CFTimeZoneRef CFTimeZoneCreateWithName (CFAllocatorRef allocator, CFStringRef name, ubyte tryAbbrev);
	CFStringRef CFTimeZoneGetName (CFTimeZoneRef tz);
	CFDataRef CFTimeZoneGetData (CFTimeZoneRef tz);
	double CFTimeZoneGetSecondsFromGMT (CFTimeZoneRef tz, double at);
	CFStringRef CFTimeZoneCopyAbbreviation (CFTimeZoneRef tz, double at);
	ubyte CFTimeZoneIsDaylightSavingTime (CFTimeZoneRef tz, double at);
	double CFTimeZoneGetDaylightSavingTimeOffset (CFTimeZoneRef tz, double at);
	double CFTimeZoneGetNextDaylightSavingTimeTransition (CFTimeZoneRef tz, double at);
	CFStringRef CFTimeZoneCopyLocalizedName (CFTimeZoneRef tz, int style, CFLocaleRef locale);
}