/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreservices.osservices.WSProtocolHandler;

//import dstep.AvailabilityMacros;
import dstep.corefoundation.CoreFoundation;
import dstep.coreservices.carboncore.MixedMode;
import dstep.coreservices.osservices.WSTypes;

struct OpaqueWSProtocolHandlerRef;

alias OpaqueWSProtocolHandlerRef* WSProtocolHandlerRef;

extern (C)
{
	alias CFTypeRef function (WSProtocolHandlerRef, CFXMLTreeRef, CFXMLTreeRef, void*) WSProtocolHandlerDeserializationProcPtr;
	alias CFStringRef function (WSProtocolHandlerRef, CFTypeRef, void*) WSProtocolHandlerSerializationProcPtr;
}

extern (C)
{
	uint WSProtocolHandlerGetTypeID ();
	WSProtocolHandlerRef WSProtocolHandlerCreate (CFAllocatorRef allocator, CFStringRef protocol);
	CFDictionaryRef WSProtocolHandlerCopyRequestDictionary (WSProtocolHandlerRef ref_, CFDataRef data);
	CFDictionaryRef WSProtocolHandlerCopyReplyDictionary (WSProtocolHandlerRef ref_, CFStringRef methodName, CFDataRef data);
	CFDataRef WSProtocolHandlerCopyReplyDocument (WSProtocolHandlerRef ref_, CFDictionaryRef methodContext, CFTypeRef resultValue);
	CFDataRef WSProtocolHandlerCopyFaultDocument (WSProtocolHandlerRef ref_, CFDictionaryRef methodContext, CFDictionaryRef faultDict);
	CFDataRef WSProtocolHandlerCopyRequestDocument (WSProtocolHandlerRef ref_, CFStringRef methodName, CFDictionaryRef methodParams, CFArrayRef methodParamOrder, CFDictionaryRef methodExtras);
	CFTypeRef WSProtocolHandlerCopyProperty (WSProtocolHandlerRef ref_, CFStringRef propertyName);
	void WSProtocolHandlerSetProperty (WSProtocolHandlerRef ref_, CFStringRef propertyName, CFTypeRef propertyValue);
	void WSProtocolHandlerSetSerializationOverride (WSProtocolHandlerRef protocol, uint objType, WSProtocolHandlerSerializationProcPtr serializationProc, WSClientContext* context);
	void WSProtocolHandlerSetDeserializationOverride (WSProtocolHandlerRef protocol, CFStringRef typeNamespace, CFStringRef typeName, WSProtocolHandlerDeserializationProcPtr deserializationProc, WSClientContext* context);
}